VERSION 5.00
Begin VB.Form frmMainForm 
   Caption         =   "iNTERFACEWARE Biztalk Example"
   ClientHeight    =   4800
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   9045
   LinkTopic       =   "Form1"
   ScaleHeight     =   4800
   ScaleWidth      =   9045
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox edtOutput 
      Height          =   3615
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   1
      Top             =   480
      Width           =   8535
   End
   Begin VB.CommandButton btnGenerate 
      Caption         =   "&Show XML Functions"
      Height          =   375
      Left            =   3120
      TabIndex        =   0
      Top             =   4320
      Width           =   2655
   End
   Begin VB.Label lblTitle 
      Caption         =   "Message Generation:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   5655
   End
End
Attribute VB_Name = "frmMainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim FlatWire As String
Dim CRLF As String
Dim LF As String
Dim CR As String
Dim ReturnBuffer As String
Const MaxOutputText = 30000
Const HalfOutputText = 15000

Private Sub HandleError(Location As String)
   DisplayOutput ("Error at " & Location & " with code: " & Str(Err.Number) & " Description: " & Err.Description)
End Sub

Private Sub DisplayOutput(Message As String)
   On Error GoTo ErrorHandler
   If Len(edtOutput.Text) > MaxOutputText Then
      ' Text control only takes 32K so we have
      ' to truncate it....
      edtOutput.Text = Right(edtOutput.Text, HalfOutputText) & Message & CRLF
   Else
      edtOutput.Text = edtOutput.Text & Message & CRLF
   End If
   
   ' The following is to ensure the box scrolls okay
   edtOutput.SelStart = Len(edtOutput.Text)
   edtOutput.SelLength = 0
   Exit Sub
ErrorHandler:
   MsgBox "Error displaying output!"
End Sub

Private Sub btnGenerate_Click()
   Dim Engine As New VMengine
   Dim Message As String, XmlResult As String, GeneratedMessage As String
   Dim Table As New VMtable
   Dim MessageIndex As Long
   
   Message = "MSH|^~\&|REGADT|MCM|RSP1P8|MCM|199601051530|SEC|ADT^A44|00000007|P|2.3" & vbCr
   Message = Message + "EVN|A44|199601051530" & vbCr
   Message = Message + "PID|||MR2^^^XYZ||JONES^WILLIAM^A^JR||19501010|M|||123 EAST STREET^^NY^NY^10021||(212)111-3333|||S||ACCT1" & vbCr
   Message = Message + "MRG|MR1^^^XYZ||ACCT1" & vbCr
   Message = Message + "MRG|MR1^^^XYZ||ACCT1" & vbCr
   Message = Message + "MRG|MR1^^^XYZ||ACCT1" & vbCr
      
   DisplayOutput (ConvertCRToCRLF(Message))
   Engine.Load App.Path + "\project.vmd"
   
   Engine.Parse Message, MessageIndex, Table
   
   DisplayOutput Table.Dump
   
   XmlResult = Engine.ParseMessageIntoXml(Message)
   
   DisplayOutput ConvertLFToCRLF(XmlResult)
   
   GeneratedMessage = Engine.ParseXmlIntoMessage(XmlResult)
   DisplayOutput ConvertCRToCRLF(GeneratedMessage)
End Sub

Private Function ConvertLFToCRLF(Original As String) As String
On Error GoTo ErrorHandler
   Dim Result As String, CharIndex As Long
   Result = ""
   For CharIndex = 1 To Len(Original)
      If LF = Mid(Original, CharIndex, 1) Then
         Result = Result & CRLF
      Else
         Result = Result & Mid(Original, CharIndex, 1)
      End If
   Next CharIndex
   ConvertLFToCRLF = Result
   Exit Function
ErrorHandler:
   HandleError "ConvertLFToCRLF"
End Function

Private Sub Engine_OnParseError(Code As Long, Description As String, MessageData As String, TreeView As String, ResultMessage As String)
   DisplayOutput Description
   ResultMessage = "ERROR" & CR
End Sub

Private Sub Form_Load()
   On Error GoTo ErrorHandler

   ' Define some useful constant strings for line feed codes
   CR = Chr(13)
   LF = Chr(10)
   
   CRLF = CR & LF

   Exit Sub
ErrorHandler:
   HandleError "Form_Load"
End Sub


Private Function ConvertCRToCRLF(Original As String) As String
   On Error GoTo ErrorHandler
   Dim Result As String, CharIndex As Long
   Result = ""
   For CharIndex = 1 To Len(Original)
      If CR = Mid(Original, CharIndex, 1) Then
         Result = Result & CRLF
      Else
         Result = Result & Mid(Original, CharIndex, 1)
      End If
   Next CharIndex
   ConvertCRToCRLF = Result
   Exit Function
ErrorHandler:
   HandleError "ConvertCRToCRLF"
End Function

